/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2007,2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СSTM32F USARTѡ
 */

#ifndef TOPPERS_USART_H
#define TOPPERS_USART_H

#include "stm32f.h"

/*
 *  SIOγߥ٥ֹ
 */
#if (SIO_PORTID == 1)
#define INHNO_SIO		IRQ_VECTOR_USART1
#define INTNO_SIO		IRQ_VECTOR_USART1
#elif (SIO_PORTID == 2)
#define INHNO_SIO		IRQ_VECTOR_USART2
#define INTNO_SIO		IRQ_VECTOR_USART2
#endif

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND    1U        /* ǽХå */
#define SIO_RDY_RCV    2U        /* ΥХå */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢݡȤδ֥å
 */
typedef struct sio_port_control_block {
	ID port;
	uint32_t reg;
	intptr_t exinf;
} SIOPCB;

/*
 *  SIO
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢ륪ץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢ륯
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  ߥϥɥ
 */
extern void sio_isr(intptr_t exinf);

/*
 *  1ʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char c);

/*
 *  1ʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  Хåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/* 
 *  Хåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

/*
 *  1ʸʥݡ󥰤Ǥνϡ
 */
extern void sio_pol_snd_chr(char c, ID siopid);

/*
 *  åȤΥꥢ
 */
extern void usart_init(ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_USART_H */
