/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2008-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.h 2268 2011-11-22 16:22:45Z ertl-honda $
 */

/*
 *  åװ¸⥸塼LM3SXXXXѡ
 *
 *  ͥΥåȰ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  åȰ¸Υϡɥ񸻤
 */
#include "lm3sxxxx.h"
#include "target_mpu.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  RAM¹ԤQEMU¹ԻROMǥХåMSP
 *  ɬפ뤿,ȥåץ롼MSP롥 
 */
#define INIT_MSP

/*
 *  ǥեȤ󥿥ƥѤΥåΰ
 */
#define DEFAULT_ISTKSZ      (0x1000U)   /* 4KByte */

/*
 *  ǥեȤΥƥॹåΰ
 */
#define DEFAULT_SSTKSZ 2048 /* 2KB */ 

/*
 *  ԤΤSILΥåȰ¸
 */
#ifndef TOPPERS_RAM_DEBUG
#define SIL_DLY_TIM1    160
#define SIL_DLY_TIM2    100
#else
#define SIL_DLY_TIM1    270
#define SIL_DLY_TIM2    140
#endif  /* TOPPERS_RAM_DEBUG */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  åȥƥ¸ν
 */
extern void	target_initialize(void);

/*
 *  åȥƥνλ
 *
 *  ƥλ˻Ȥ
 */
extern void	target_exit(void) NoReturn;


/*
 *	ƥȥ֥å
 */
#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

typedef struct task_initialization_context_block {
	SIZE	sstksz;			/* åΰΥʴݤ᤿͡ */
	void	*sstk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
	SIZE	stksz;			/* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
    char *start_ustk_label;
    uint32_t atrsz_ustk;
} TSKINICTXB;

/*
 *  ݸɥᥤƥȥ֥å
 */

#define USE_DOMINICTXB	/*  TSKINICTXBѤ  */

typedef struct {
    char *start_rom_label;
    uint32_t atrsz_rom;
    char *start_ram_label;
    uint32_t atrsz_ram;
    char *start_srpw_label;
    uint32_t atrsz_srpw;
} DOMINIB_INFO;

typedef struct {
    DOMINIB_INFO *p_dominib_info;
} DOMINICTXB;

/*
 *  桼ø⡼ɼ¹椫
 *  priv_modeϡӥ롢ӡĥӥ
 *  true˥åȤ
 */
#define t_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define i_sense_priv(p_tcb)   ((p_tcb)->tskctxb.priv_mode)
#define t_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)
#define i_sense_priv_runtsk() ((p_runtsk)->tskctxb.priv_mode)

#define USRTEX_STKSZ ((8+2)*4)
/*
 *  åؤΥåΤΥޥ
 */
#ifndef PROBE_STACK
#define PROBE_STACK(sp, size) \
				(ALIGN_TYPE(sp, uint32_t) && probe_stack(sp, size))
#endif /* PROBE_STACK */


extern bool_t i_check_tex_runtsk();

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ¸⥸塼ARM-Mѡ
 */
#include "core_config.h"

#endif /* TOPPERS_TARGET_CONFIG_H */
