/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 *	
 *	Copyright (C) 2012 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 */

/*
 *	MPUɥ饤СLM3SXXXXѡ
 */

#include "kernel_impl.h"
#include "task.h"
#include "memory.h"
#include <sil.h>
#include "kernel_cfg.h"
#include "target_mpu.h"

void
target_mpu_initialize(void)
{
    char *shared_mem_base;
    char *shared_mem_attr;

    sil_wrw_mem((void *)(MPU_REGNO), (uint32_t)(0));
    /*
     *  ΰ0: ͭ꡼ΰ
     */
    shared_mem_base = shared_meminib_table[0];
    shared_mem_attr = shared_meminib_table[1];
    sil_wrw_mem((void *)(MPU_REGBASE), (uint32_t)shared_mem_base);
    sil_wrw_mem((void *)(MPU_REGATR),  (uint32_t)shared_mem_attr);

    /*
     *  ΰ1: ͭ꡼ɥ饤ΰ
     */
    shared_mem_base = shared_meminib_table[2];
    shared_mem_attr = shared_meminib_table[3];
    sil_wrw_mem((void *)(MPU_REGBASE), (uint32_t)shared_mem_base);
    sil_wrw_mem((void *)(MPU_REGATR),  (uint32_t)shared_mem_attr);

    /*
     *  ΰ2: ͭ꡼ͭ饤ΰ
     */
    shared_mem_base = shared_meminib_table[4];
    shared_mem_attr = shared_meminib_table[5];
    sil_wrw_mem((void *)(MPU_REGBASE), (uint32_t)shared_mem_base);
    sil_wrw_mem((void *)(MPU_REGATR),  (uint32_t)shared_mem_attr);

    /*
     *  MPUͭ
     *  ø⡼ɤǤϥǥեȤΥޥå
     *  ϥɥǤMPU̵
     */
    sil_wrw_mem((void *)(MPU_CR), (uint32_t)(MPU_CR_PRIVDEFENA | MPU_CR_ENABLE));
}

void
target_mpu_exc_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "MPU EXCEPTION OCCURED!!");
    while(1);
}

// 㳰¹Գϻåϥɥ
void
target_emulate_texrtn_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at prepare texrtn.");
    while(1);
}

// 㳰꥿åϥɥ
void
target_emulate_ret_tex_handler(void *p_excinf)
{
    syslog(LOG_EMERG, "User stack is no space at return texrtn.");
    while(1);
}

