/*
 *  TOPPERS/HRP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      High Reliable system Profile Kernel
 * 
 *  Copyright (C) 2008-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_timer.h 2183 2011-07-23 10:29:36Z ertl-honda $
 */

/*
 *  ޥɥ饤СLM3SXXXXѡ
 */

#ifndef TOPPERS_TARGET_TIMER_H
#define TOPPERS_TARGET_TIMER_H

#include "lm3sxxxx.h"
#include "inc/hw_ints.h"

/*
 *  ͤɽȥߥñ̤ȤѴ
 */
#define TIMER_CLOCK 50000

/*
 *  ޳ߥϥɥϿΤ
 */
#define INTPRI_TIMER    (-6)          /* ͥ */
#define INTATR_TIMER    0U            /* ° */

/*
 *  ¸⥸塼ARM-Mѡ
 */
#include "arm_m_gcc/common/core_timer.h"

#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *  GPTM0_AѤ
 */

/*
 *	޳ߥϥɥϿΤ
 */
#define INHNO_OVRTIMER 	INT_TIMER0A   /* ߥϥɥֹ */
#define INTNO_OVRTIMER 	INT_TIMER0A   /* ֹ */
#define INTPRI_OVRTIMER	(-7)		  /* ͥ */
#define INTATR_OVRTIMER	0U			  /* ° */

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */

#ifndef TOPPERS_MACRO_ONLY
#ifdef TOPPERS_TARGET_SUPPORT_OVRHDR
/*
 *  ͤɽȥޥñ̤ȤѴ
 */
#define OVRTIMER_CLOCK_UNIT 50
/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_OVRTIMER_CLOCK    ((CLOCK) 0xffffffffU)
/*
 *	ͤɽȥޥñ̤ȤѴ
 *	1secΥåȿ
 */
#define OVRTIMER_CLOCK(usec) ((usec) * OVRTIMER_CLOCK_UNIT)
#define OVRTIMER_USEC(clock) ((clock) / OVRTIMER_CLOCK_UNIT)

/*
 *	Х󥿥ޤν
 *
 *	ޤ롥
 */
extern void target_ovrtimer_initialize(intptr_t exinf);

/*
 *	Х󥿥ޤνλ
 *
 *	ޤưλ롥
 */
extern void target_ovrtimer_terminate(intptr_t exinf);

/*
 *	Х󥿥ޤεư
 *
 *	ޤư롥
 */
extern void target_ovrtimer_start(OVRTIM ovrtim);

/*
 *	Х󥿥ޤ߽
 *
 *	ޤưߤ롥
 */
extern OVRTIM target_ovrtimer_stop(void);

/*
 *	Х󥿥ޤθͤɽФ
 */
extern OVRTIM target_ovrtimer_get_current(void);

/*
 *	Х󥿥޳ߥϥɥ
 */
extern void target_ovrtimer_handler(void);

/*
 *  Хϥɥ鵯ư롼
 */
extern void	call_ovrhdr(void);

#endif /* TOPPERS_TARGET_SUPPORT_OVRHDR */
#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TARGET_TIMER_H */
